.AUTODEPEND

.PATH.obj = LIB

#		*Translator Definitions*
CC = bcc +CLIB.CFG
TASM = TASM
TLIB = tlib
TLINK = tlink
LIBPATH = CLIB;\BORLANDC\LIB
INCLUDEPATH = CLIB;INC;\BORLANDC\INCLUDE;\BORLANDC\CRTL\RTLINC;\BORLANDC\TVISION\INCLUDE


#		*Implicit Rules*
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

#		*List Macros*


LIB_dependencies =  \
 initvid.obj \
 ioctl.obj \
 pgetrows.obj \
 dpmish.obj \
 malloc.obj \
 startup.obj \
 getenv.obj \
 heaplen.obj

#		*Explicit Rules*
lib\clib.lib: clib.cfg $(LIB_dependencies)
  - del lib\clib.lib
  $(TLIB) $<  @&&|
-+lib\initvid.obj &
-+lib\ioctl.obj &
-+lib\pgetrows.obj &
-+lib\dpmish.obj &
-+lib\malloc.obj &
-+lib\startup.obj &
-+lib\getenv.obj &
-+lib\heaplen.obj
|


#		*Individual File Dependencies*
initvid.obj: clib.cfg clib\initvid.cpp 
	$(CC) -c clib\initvid.cpp

ioctl.obj: clib.cfg clib\ioctl.cpp 
	$(CC) -c clib\ioctl.cpp

pgetrows.obj: clib.cfg clib\pgetrows.cpp 
	$(CC) -c clib\pgetrows.cpp

dpmish.obj: clib.cfg clib\dpmish.cpp 
	$(CC) -c clib\dpmish.cpp

malloc.obj: clib.cfg clib\malloc.cpp 
	$(CC) -c clib\malloc.cpp

startup.obj: clib.cfg clib\startup.cpp 
	$(CC) -c clib\startup.cpp

getenv.obj: clib.cfg clib\getenv.cpp 
	$(CC) -c clib\getenv.cpp

heaplen.obj: clib.cfg clib\heaplen.cpp 
	$(CC) -c clib\heaplen.cpp

#		*Compiler Configuration File*
clib.cfg: clib.mak
 -copy &&|
-ml!
-v
-vi-
-wpro
-weas
-wpre
-nLIB
-I$(INCLUDEPATH)
-L$(LIBPATH)
-DPROTECT
-zC_TEXT
-zR_DATA
-zTDATA
| clib.cfg


