{$M 65520,0,0}
uses crt,dos,tesstp55,bignum;
type
      videorecs = record
         videomode:                      byte;
         numcol:                         word;
      end;
const
   days : array[0..7] of string[9] =
   ('Sunday',
   'Monday',
   'Tuesday',
   'Wednesday',
   'Thursday',
   'Friday',
   'Saturday',
   'Invalid!');

   months : array[1..12] of string[9] =
   ('January',
   'February',
   'March',
   'April',
   'May',
   'June',
   'July',
   'August',
   'September',
   'October',
   'November',
   'December');

var
   month,day: byte;
   year:  string;
   videorec: videorecs absolute $0040:$0049;
   choice: char;
   dait: string;
   x,y,h,l: byte;
   result: registers;
   ticks: word;
   bad: boolean;
   ly: boolean;

procedure strip(var v: string);
   var
      dp: byte;
   begin
      dp := pos('.',v);
      if dp >0 then
         begin
            if (v[1]='-') and ((v[dp+1]<>'0') or (v[dp+2]<>'0')) then
               v := minus(v,'1',true);
            v := copy(v,1,dp-1);
         end;
      if v='' then
         v :='0';
      if v='-' then
         v :='-1';
   end;

procedure strip2(var v: string);
   var
      dp: byte;
   begin
      dp := pos('.',v);
      if dp >0 then
         v := copy(v,1,dp-1);
      if v='' then
         v :='0';
      if v='-' then
         v :='-1';
   end;

PROCEDURE c_str( row : integer; str : string );
					{ Print a string, centered	  }
  VAR
    wid : integer;			{ temporary width variable	  }
  BEGIN
    wid := (videorec.numcol - length(str)) SHR 1;	{ calculate cursor position	  }
    if wid=40 then
       wid :=1;
    gotoxy(wid, row);			{ go there			  }
    write(str); 			{ display the string		  }
  END;

procedure curget(var x,y,h,l: byte);
   begin
      result.ah := 3;
      result.bh :=0;
      intr($10,result);
      h := result.ch;
      l := result.cl;
      x := result.dl+1;
      y := result.dh+1;
   end;

procedure offleadzero(var s: string);
   var
      zeros: boolean;
   begin
      zeros := true;
      while (length(s) >1) and (zeros) do
         begin
            if s[1]='0' then
               s := copy(s,2,length(s))
            else
               zeros := false;
         end;{while}
      if s = '.' then
         s := '0';
end;{offleadzero}

procedure accept(var v: byte);
   var
       tmp_str : string;
       ch2 : char;
   begin
      ch2 := ' ';
      tmp_str :='';
      while (tmp_str[0]<>chr(2)) and (ch2<>chr(13)) do
         begin
            ch2 := readkey;
            if ch2 in ['0'..'9'] then
               begin
                  tmp_str := tmp_str + ch2;
                  write(ch2);
               end
            else
               if ch2 = chr(8) then
                  begin
                     if tmp_str[0] <> chr(0) then
                        begin
                           tmp_str[0] := chr(ord(tmp_str[0])-1);
                           curget(x,y,h,l);
                           gotoxy(x-1,y);
                           write(' ');
                           gotoxy(x-1,y);
                        end;
                  end
               else
                  if ch2 = chr(27) then
                     begin
                        offleadzero(tmp_str);
                        val(tmp_str,v,ticks);
                        if ticks<>0 then
                        v :=1;
                        if v=0 then
                           v :=1;
                        ticks := 0;
                        exit;
                     end;
         end;
      if tmp_str ='' then
         tmp_str :='1';
      offleadzero(tmp_str);
      val(tmp_str,v,ticks);
      if ticks<>0 then
         v :=1;
      ticks := 0;
   end;

procedure accept2(var v: string);
   var
       tmp_str : string;
       ch2 : char;
       neg: boolean;
   begin
      neg := false;
      ch2 := ' ';
      tmp_str :='';
      while (tmp_str[0]<>chr(32)) and (ch2<>chr(13)) do
         begin
            ch2 := readkey;
            if ch2 in ['0'..'9','-'] then
               begin
                  if (ch2 = '-') and (tmp_str[0]>chr(0)) then
                     tessbeep
                  else
                     begin
                        tmp_str := tmp_str + ch2;
                        write(ch2);
                     end;
               end
            else
               if ch2 = chr(8) then
                  begin
                     if tmp_str[0] <> chr(0) then
                        begin
                           tmp_str[0] := chr(ord(tmp_str[0])-1);
                           curget(x,y,h,l);
                           gotoxy(x-1,y);
                           write(' ');
                           gotoxy(x-1,y);
                        end;
                  end
               else
                  if ch2 = chr(27) then
                     begin
                        v := tmp_str;
                        if pos('-',v)<>0 then
                           begin
                              neg := true;
                              v := copy(v,2,length(v));
                           end;
                        offleadzero(v);
                        if tmp_str ='' then
                         v :='0';
                         if neg then
                            v := '-' + v;
                         if v='-0' then
                            v :='0';
                        exit;
                     end;
         end;

      v := tmp_str;
                        if pos('-',v)<>0 then
                           begin
                              neg := true;
                              v := copy(v,2,length(v));
                           end;
      offleadzero(v);
      if neg then
         v := '-' + v;
      if v='-0' then
         v :='0';
      if tmp_str ='' then
         v :='0';
{      val(v,yr,ticks);}
   end;

function Weekday(var month,day: byte; year: string): string;
   var
      yo: string;
      mo: string;
      d: string;
      date: string;
      x: char;
      t1,t2,t3,t4: string;
      dp: shortint;
      yr: comp;



   begin
      str(month,mo);
      if month>2 then
         begin
            mo := plus(mo,'1',true);
            yo := year;
         end
      else
         begin
            mo := plus(mo,'13',true);
            yo := year;
            yo := minus(yo,'1',true);
         end;

{   date := int(365.25 * yo) + int(30.6001 * mo) + day +5;}

   t1 := times('365.25',yo,true);
   t2 := times('30.6001',mo,true);
   strip(t1);
   strip(t2);
   str(day,t3);
   t3 := plus(t3,'5',true);
   t1 := plus(t1,t2,true);
   date := plus(t1,t3,true);
{   val(date,yr,ticks);}
{   if ((date[1]='-') or (year='0')) then
      begin
         date := plus(date,'419999999999999999999999999999999999',true);
         take_out := 1;
      end;}

{   if length(date)<=2 then
      begin
         date := plus(date,'419999999999999999999999999999999999',true);
         take_out := 1;
      end;}

   dait := divide(date,'7',true,true);
   if dait='-0' then
      dait :='0';
   dait := times(dait,'7',true);
   dait := minus(date,dait,true);
   dp := pos('-',dait);
   if dp>0 then
      dait := plus(dait,'7',true);
   val(dait,dp,ticks);
   if dp<0 then
      dp := dp+7;
   dait := date;
   weekday := days[dp];
end;{weekday}

procedure usermenu;
   begin
      clrscr;
      textcolor(yellow);
      textbackground(red);
      c_str(1,'CALENDAR MENU OPTIONS.');
      textcolor(white);
      textbackground(blue);
      c_str(12,'1-Day of Week Calculations.');
      c_str(13,'2-How far Two Dates Are From Each Other.');
      c_str(14,'3-Date Arithmetic/Add-subtract from a date.');
      c_str(25,'<ESC>-Exit Program.');
      textbackground(black);
   end;

procedure dayofweek;
   var
      month,day: byte;
      year: string;
      c: char;
      dow: string;
      label
         mo,da,ye;
   begin
      clrscr;
      textcolor(yellow);
      textbackground(red);
      c_str(1,'ENTER DATE TO FIND WHAT DAY IT FALLS ON.');
      textcolor(yellow);
      textbackground(black);
ye:      c_str(11,'Enter year: ');
      clreol;
      accept2(year);
      if year='-' then
         year :='1';
      if times(divide(year,'4',true,true),'4',true) = year then
         ly := true
      else
         ly := false;
mo:   bad := false;
      c_str(12,'Enter month (1-12): ');
      clreol;
      accept(month);
      if ticks <>0 then
         bad := true;
      if bad then
         begin
            tessbeep;
            goto mo;
         end;
   if (month<1) or (month>12) then
      begin
         tessbeep;
         goto mo;
      end;
da:   bad := false;
      c_str(13,'Enter day (1-31), (1-30) or (1-28/29): ');
      clreol;
      accept(day);
      if ticks <>0 then
         bad := true;
      if bad then
         begin
            tessbeep;
            goto da;
         end;

      if (day<1) or (day>31) then
         begin
            tessbeep;
            goto da;
         end;

      case month of
      4,6,9,11: begin
                   if day>30 then
                      begin
                         tessbeep;
                         goto da;
                      end;
                end;
      2:        begin
                   if ly then
                      begin
                         if day>29 then
                            begin
                               tessbeep;
                               goto da;
                            end;
                      end
                   else
                      begin
                         if day>28 then
                            begin
                               tessbeep;
                               goto da;
                            end;
                      end;
                end;
      end;{Cases}

{      if int(year / 4) * 4 = year then
         ly := true
      else
         ly := false;}

      writeln('');
      dow := weekday(month,day,year);
      writeln(months[month],' ',day,', ',year,' Falls on a ',dow,'.');
      if ly then
         writeln(year,' is a leap year.')
      else
         writeln(year,' is not a leap year.');
      c_str(18,'Press any key to continue.');
      c := readkey;
   end;

{procedure convert(juldate: string);
   var
      a,b,c,d,e,z,alpha: string;
      month,day,year: string;
      x: char;
   begin
      clrscr;
      writeln(dait);
      z := juldate + 1;
      if z<2299161 then
         a := 2
      else
         begin
            alpha := (z-1867216.25)/36524.25;
            a := z+1+alpha-alpha/4;
         end;
      b := a+1524;
      c := a-122.1/365.25;
      d := 365.25 *c;
      e := b-d/30.6001;
      day := int(b-d-30.6001*e);
      if e<13.5 then
         month := int(e-1)
      else
         month := int(e-13);
      if month > 2.5 then
         year := int(c-4716)
      else
         year := int(c-4715);
      writeln(month:15:0,' ',day:15:0,' ',year:15:0);
      writeln('Any key to continue.');
      x := readkey;
   end;}

procedure far;
   var
      dayt1,dayt2: string;
      c: char;
      mo,da,days,ye: string;

   begin
      clrscr;
      textcolor(yellow);
      textbackground(red);
      c_str(1,'HOW FAR 2 DATES ARE FROM ONE ANOTHER!');
      textcolor(yellow);
      textbackground(black);
      c_str(10,'');
      c_str(10,'You will be asked to enter dates twice.');
      c_str(11,'You will then be given the spread in days.');
      c_str(12,'You will now enter your first date.');
      c_str(13,'Press any key to start.');
      c := readkey;
      dayofweek;
{      if take_out <>0 then
         dait := minus(dait,'420000000000000000000000000000000000',true);}
      dayt1 := dait;

      textcolor(yellow+blink);
      c_str(10,'You will now enter your second date.');
      c_str(11,'Press any key to start.');
      clreol;
      textcolor(yellow);
      c := readkey;
      dayofweek;
{      if take_out <>0 then
         dait := minus(dait,'420000000000000000000000000000000000',true);}
      dayt2 := dait;
      dayt1 := minus(dayt2,dayt1,true);
      days := dayt1;
      ye := divide(dayt1,'365',true,true);
      if ye='-0' then
         ye :='0';
      dayt1 := minus(dayt1,times(ye,'365',true),true);
      mo := divide(dayt1,'30.4375',true,true);
      if mo='-0' then
         mo := '0';
      dayt1 := minus(dayt1,times(mo,'30.4375',true),true);
      da := dayt1;
      if pos('-.',da)>0 then
         da :='0'
      else;
{         if pos('-',da)>0 then
            da := plus(da,'1',true);}
      strip2(da);
      c_str(18,'                                                                       ');
      c_str(19,'                                                                       ');
      c_str(20,'                                                                       ');
      c_str(18,'The dates are '+ye +' years,');
      c_str(19,mo +' months and ');
      c_str(20,da +' days apart.');
      c_str(21,'Total days between dates='+days);
      c_str(25,'Press any key to exit.');
      c := readkey;
   end;

procedure date_arithmatic(dait: string; var month,day: byte; var year: string; var day_of: string);
   var
      m,d,y: string;
      dayt2: string;
      mo,da: shortint;
      dow: string[9];
      ly: boolean;
      testy: string;
   begin
      dayt2 := dait;
      dait := minus(dait,'5',true);
      y := divide(dait,'365.25',true,true);

      if dait='0' then
         y := '-'+y;
      if pos('-',y)>0 then
         y := minus(y,'1',true);

      if times(divide(y,'4',true,true),'4',true)=y then
         ly := true
      else
         ly := false;


      dait := minus(dait,times(y,'365.25',true),true);
      m := divide(dait,'30.6001',true,true);
      if (m='-0') or (m='-') then
         m :='0';

      dait := minus(dait,times(m,'30.6001',true),true);
      d := dait;
      if pos('.',d)>0 then
         d := copy(d,1,pos('.',d)-1);
      if d='-' then
         d :='0';

      val(m,mo,ticks);
      val(d,da,ticks);
      mo := mo-1;

{      testy := y;
      if mo<=0 then
         testy := minus(testy,'1',true);
      if times(divide(testy,'4',true,true),'4',true)=testy then
         ly := true
      else
         ly := false;}

         testy := times(divide(plus(y,'1',true),'4',true,true),'4',true);
         if (y='0') and (mo=-1) then
            testy := '1';
         if testy = plus(y,'1',true) then
            begin
               case mo of
               3,5,8,10: da := da+1;
               -1: if plus(y,'1',true)='1' then
                   da := da-1;
               end;
            end
         else
            if times(divide(minus(y,'1',true),'4',true,true),'4',true)=
            minus(y,'1',true) then
               begin
                  case mo of
                  0: da := da -1;
                  end;
               end;

      if (times(divide(y,'2',true,true),'2',true)=y) and not (ly)
         then
            begin
               case mo of
               5,10: da := da+1;
               end;
            end;

      case mo of
      1: if not (ly) then
            da := da-1;
{      2: begin
            if (ly) and (da>=1) and (y[1]='-') then
               da := da-2
            else
               if da>=0 then
                  da := da-1;
         end;}
      2: da := da-1;
      3,4,5,6,8,9,10:  da := da+1;
      7: if not(ly) then
            da := da+2
         else
            da := da+1;

{      7: if (da>=1) and (da<=29) and (not (ly)) and ((y[1]='0')) then
            da := da+2
         else
            da := da+1;}
      -1: begin
             y := minus(y,'1',true);
             mo := mo + 12;
             if pos('-',y)=0 then
                da := da-1
             else
                if y[2]<>'1' then
                   da := da-1;
          end
      end;{cases}

      if da<=0 then
         begin
            mo := mo-1;
            if mo=0 then
               begin
                  y := minus(y,'1',true);
                  mo := mo+12;
               end;

            case mo of
            9,4,6,11: da := da + 30;
            2: if ly then
                  da := da+29
               else
                  da := da+28;
            else
               da := da+31;
            end;{cases}
         end;

      if da=31 then
         begin
            if mo in[4,6,9,11] then
               begin
                  da :=1;
                  mo := mo+1;
               end;
         end;

      if da>31 then
         begin
            if  mo in[1,3,5,7,8,10,12] then
               begin
                  da := da-31;
                  mo := mo+1;
               end;
         end;

      if (mo=2) and (da>28) and not(ly) then
         begin
            mo := mo+1;
            da := da -28;
         end;

      if mo<1 then
         begin
            mo := mo+12;
            y := minus(y,'1',true);
            if da>29 then
               case mo of
               9,4,6,11: da  := da-1;
               end;
         end;

      month := mo;
      day := da;
      year := y;
      day_of := weekday(month,day,year);
   end;

procedure date_time;
   var f: text;
       m,d: byte;
       y: string;
       idx: longint;
       test: longint;
       dt: string;
       scale: string;
       dow: string;
       ds,ms,ys: string;
       your_at: byte;
       yup: string;
       mo_chk: shortint;
       c: char;
   begin
{     assign(f,'temp');
      rewrite(f);
      for idx := -2854 to 3355 do
         begin
            take_out :=0;
            str(idx,dt);
            date_arithmatic(dt,m,d,y,dow);
            writeln(months[m],' ',d,', ',y,' ',dow);
            writeln(f,months[m],' ',d,', ',y,' ',dow);
            val(dait,test,ticks);
            if test<>idx then
               begin
                  writeln(dait);
                  c := readkey;
               end;
         end;
      close(f);
      c := readkey;}
            clrscr;
            textcolor(yellow);
            textbackground(red);
            c_str(1,'Date Arithmetic.  Add/Subtract from dates.');
            textbackground(black);
            c_str(12,'You will first enter a date.');
            c_str(13,'Then you will be able to add and subtract from it.');
            c_str(14,'Press any key to continue.');
            c := readkey;
            dayofweek;
            dt := dait;
            clrscr;
            date_arithmatic(dt,m,d,y,dow);
            textcolor(yellow);
            textbackground(red);
            c_str(1,'Date Arithmetic.  Add/Subtract from dates.');
            c :=' ';
            ds :='1';
            ms :='1';
            ys :='1';
            your_at :=1;

            while c<>chr(27) do
               begin
                  textbackground(red);
                  c_str(25,'D=day. M=month. Y=year. S=scale/change scale. <Enter>=Add/Subtract.');
                  c_str(22,'Blinking shows which item you are working on.');
                  c_str(23,'Negative Scale is used for subtracting from blinking item.');
                  c_str(24,'If day is blinking, then pressing enter affects day.');
                  case c of
                  'd','D': your_at := 1;
                  'm','M': your_at := 2;
                  'y','Y': your_at := 3;
                  's','S': begin
                              gotoxy(10,3);
                              textbackground(black);
                              case your_at of
                              1: begin
                                    writeln('Enter New Day Scale.');
                                    accept2(ds);
                                    if ds='-' then
                                       ds :='-1';
                                 end;
                              2: begin
                                    writeln('Enter New Month Scale.');
                                    accept2(ms);
                                    if ms='-' then
                                       ms :='-1';
                                 end;
                              3: begin
                                    writeln('Enter New Year Scale.');
                                    accept2(ys);
                                    if ys='-' then
                                       ds :='-1';
                                 end;
                              end;
                              gotoxy(10,3);
                              clreol;
                              gotoxy(1,4);
                              clreol;
                           end;
                  chr(13): begin
                              case your_at of
                              1: begin
                                    dt := plus(dt,ds,true);
                                    date_arithmatic(dt,m,d,y,dow);
                                 end;
                              2: begin
                                    yup := divide(ms,'12',true,true);
                                    if yup='-0' then
                                       yup :='0';
                                    y := plus(y,yup,true);
                                    yup := minus(ms,times(yup,'12',true),true);
                                    val(yup,mo_chk,ticks);
                                    mo_chk := m+mo_chk;
                                    if mo_chk<=0 then
                                       begin
                                          mo_chk := mo_chk+12;
                                          y := minus(y,'1',true);
                                       end;
                                    if mo_chk>12 then
                                       begin
                                          mo_chk := mo_chk-12;
                                          y := plus(y,'1',true);
                                       end;
                                    m := mo_chk;
                                    dow := weekday(m,d,y);
                                    dt := dait;
                                 end;
                              3: begin
                                    y := plus(y,ys,true);
                                    dow := weekday(m,d,y);
                                    dt := dait;
                                 end;
                              end;{date arithmetic cases.}
                           end;
                  end;{entry key cases.}

                  textbackground(black);
                  gotoxy(10,10);
                  if your_at=2 then
                     textcolor(yellow+blink);
                  write(months[m]);
                  textcolor(yellow);
                  write(' ');
                  if your_at=1 then
                     textcolor(yellow+blink);
                  write(d);
                  textcolor(yellow);
                  write(', ');
                  if your_at=3 then
                     textcolor(yellow+blink);
                  write(y);
                  textcolor(yellow);
                  writeln(' Falls on a ',dow,'.                                                     ');
                  gotoxy(10,11);
                  if times(divide(y,'4',true,true),'4',true)=y then
                     writeln(y,' is a leap year.                                                 ')
                  else
                     writeln(y,' is not a leap year.                                                 ');

                  gotoxy(1,14);
                  write('Year Scale=',ys);
                  clreol;
                  gotoxy(1,15);
                  write('Month Scale=',ms);
                  clreol;
                  gotoxy(1,16);
                  write('Day Scale=',ds);
                  clreol;
                  c := readkey;
               end;
   end;

begin
   directvideo := false;
   usermenu;
   choice :=' ';
   while choice <>chr(27) do
      begin
         choice := readkey;
         case choice of
         '1': dayofweek;
         '2': far;
         '3': date_time;
         end;
         usermenu;
      end;
      clrscr;
end.